import { Primitive } from '@radix-ui/react-primitive';
import * as RovingFocusGroup from '@radix-ui/react-roving-focus';
import * as React from 'react';

type InputType = 'password' | 'text';
type AutoComplete = 'off' | 'one-time-code';
type InputValidationType = 'alpha' | 'numeric' | 'alphanumeric' | 'none';
type RovingFocusGroupProps = React.ComponentPropsWithoutRef<typeof RovingFocusGroup.Root>;
interface OneTimePasswordFieldOwnProps {
    onValueChange?: (value: string) => void;
    id?: string;
    value?: string;
    defaultValue?: string;
    autoSubmit?: boolean;
    onAutoSubmit?: (value: string) => void;
    validationType?: InputValidationType;
    disabled?: boolean;
    readOnly?: boolean;
    autoComplete?: AutoComplete;
    autoFocus?: boolean;
    form?: string | undefined;
    name?: string | undefined;
    placeholder?: string | undefined;
    required?: boolean;
    type?: InputType;
    dir?: RovingFocusGroupProps['dir'];
    orientation?: RovingFocusGroupProps['orientation'];
}
interface OneTimePasswordFieldProps extends OneTimePasswordFieldOwnProps, Omit<React.ComponentPropsWithoutRef<typeof Primitive.div>, keyof OneTimePasswordFieldOwnProps> {
}
declare const OneTimePasswordField: React.ForwardRefExoticComponent<OneTimePasswordFieldProps & React.RefAttributes<HTMLDivElement>>;
interface OneTimePasswordFieldHiddenInputProps extends Omit<React.ComponentProps<'input'>, keyof 'value' | 'defaultValue' | 'type' | 'onChange' | 'readOnly' | 'disabled' | 'autoComplete' | 'autoFocus'> {
}
declare const OneTimePasswordFieldHiddenInput: React.ForwardRefExoticComponent<Omit<OneTimePasswordFieldHiddenInputProps, "ref"> & React.RefAttributes<HTMLInputElement>>;
interface OneTimePasswordFieldInputOwnProps {
    autoComplete?: 'one-time-code' | 'off';
}
interface OneTimePasswordFieldInputProps extends OneTimePasswordFieldInputOwnProps, Omit<React.ComponentProps<typeof Primitive.input>, keyof OneTimePasswordFieldInputOwnProps> {
}
declare const OneTimePasswordFieldInput: React.ForwardRefExoticComponent<Omit<OneTimePasswordFieldInputProps, "ref"> & React.RefAttributes<HTMLInputElement>>;
declare const Root: React.ForwardRefExoticComponent<OneTimePasswordFieldProps & React.RefAttributes<HTMLDivElement>>;
declare const Input: React.ForwardRefExoticComponent<Omit<OneTimePasswordFieldInputProps, "ref"> & React.RefAttributes<HTMLInputElement>>;
declare const HiddenInput: React.ForwardRefExoticComponent<Omit<OneTimePasswordFieldHiddenInputProps, "ref"> & React.RefAttributes<HTMLInputElement>>;

export { HiddenInput, Input, type InputValidationType, OneTimePasswordField, OneTimePasswordFieldHiddenInput, type OneTimePasswordFieldHiddenInputProps, OneTimePasswordFieldInput, type OneTimePasswordFieldInputProps, type OneTimePasswordFieldProps, Root };
